/*
 * ValueHolderInterface.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _VALUE_INTERFACE_HPP_
#define _VALUE_INTERFACE_HPP_

#include <abstraction/Value.hpp>

namespace abstraction {

class ValueInterface : public Value {
	bool m_isTemporary;

	bool m_isCastedToTemporaryRvalue = false;

protected:
	ValueInterface ( bool isTemporary ) : m_isTemporary ( isTemporary ) {
	}

public:
	bool isConst ( ) const {
		return getTypeQualifiers ( ) && ParamQualifiers::ParamQualifierSet::CONST;
	}

	bool isRef ( ) const {
		return isRvalueRef ( ) || isLvalueRef ( );
	}

	bool isRvalueRef ( ) const {
		if ( m_isCastedToTemporaryRvalue )
			return true;
		return getTypeQualifiers ( ) && ParamQualifiers::ParamQualifierSet::RREF;
	}

	bool isLvalueRef ( ) const {
		if ( m_isCastedToTemporaryRvalue )
			return false;
		return getTypeQualifiers ( ) && ParamQualifiers::ParamQualifierSet::LREF;
	}

	bool isTemporary ( ) const {
		return m_isTemporary || m_isCastedToTemporaryRvalue;
	}

	void castToTemporaryRvalue ( ) { //FIXME I do not like this method
		m_isCastedToTemporaryRvalue = true;
	}

};

} /* namespace abstraction */

#endif /* _VALUE_INTERFACE_HPP_ */
