#ifndef _TYPE_EXPRESSION_H_
#define _TYPE_EXPRESSION_H_

#include <ast/Expression.h>
#include <string>

namespace cli {

class TypeExpression final : public Expression {
	std::unique_ptr < Expression > m_expression;

public:
	TypeExpression ( std::unique_ptr < Expression > expression ) : m_expression ( std::move ( expression ) ) {
	}

	std::shared_ptr < abstraction::Value > translateAndEval ( Environment & environment ) const override {
		std::shared_ptr < abstraction::Value > translatedExpression = m_expression->translateAndEval ( environment );

		return std::make_shared < abstraction::ValueHolder < std::string > > ( translatedExpression->getType ( ), true );
	}

};

} /* namespace cli */

#endif /* _TYPE_EXPRESSION_H_ */
