/*
 * Move.h
 *
 *  Created on: 18. 12. 2019
 *	  Author: Jan Travnicek
 */

#ifndef _MOVE_H_
#define _MOVE_H_

#include <abstraction/ValueInterface.hpp>

namespace cli {

namespace builtin {

/**
 * Builtin move on abstraction values.
 *
 */
class Move {
public:
	static std::shared_ptr < abstraction::Value > move ( std::vector < std::shared_ptr < abstraction::Value > > params ) {
		if ( std::static_pointer_cast < abstraction::ValueInterface > ( params [ 0 ] )->isTemporary ( ) ) {
			abstraction::ParamQualifiers::ParamQualifierSet paramQualifiers = abstraction::ParamQualifiers::ParamQualifierSet::RREF;
			if ( params [ 0 ]->getTypeQualifiers ( ) && abstraction::ParamQualifiers::ParamQualifierSet::CONST )
				paramQualifiers = paramQualifiers | abstraction::ParamQualifiers::ParamQualifierSet::CONST;

			return params [ 0 ]->clone ( paramQualifiers, true );
		} else {
			abstraction::ParamQualifiers::ParamQualifierSet paramQualifiers = abstraction::ParamQualifiers::ParamQualifierSet::LREF;
			if ( params [ 0 ]->getTypeQualifiers ( ) && abstraction::ParamQualifiers::ParamQualifierSet::CONST )
				paramQualifiers = paramQualifiers | abstraction::ParamQualifiers::ParamQualifierSet::CONST;

			std::shared_ptr < abstraction::Value > cloned = params [ 0 ]->clone ( paramQualifiers, false );
			std::static_pointer_cast < abstraction::ValueInterface > ( cloned )->castToTemporaryRvalue ( );

			abstraction::ParamQualifiers::ParamQualifierSet paramQualifiers2 = abstraction::ParamQualifiers::ParamQualifierSet::RREF;
			if ( params [ 0 ]->getTypeQualifiers ( ) && abstraction::ParamQualifiers::ParamQualifierSet::CONST )
				paramQualifiers2 = paramQualifiers2 | abstraction::ParamQualifiers::ParamQualifierSet::CONST;
			return cloned->clone ( paramQualifiers2, true );
		}
	}
};

} /* namespace builtin */

} /* namespace cli */

#endif /* _MOVE_H_ */
